'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _util = require('util');

var _util2 = _interopRequireDefault(_util);

var _qmFsIfexists = require('qm-fs-ifexists');

var _qmFsIfexists2 = _interopRequireDefault(_qmFsIfexists);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const writeFile = _util2.default.promisify(_fs2.default.writeFile); //TODOC: node 8 only

async function touch(pathToFile, content, options = {}) {
  const { //TODOC:  options
    encoding = 'utf8',
    overwrite = false
  } = options;
  const pathIfExists = await (0, _qmFsIfexists2.default)(pathToFile, { asBoolean: true });
  overwrite === false && pathIfExists && throwErrorCannotOverWrite(pathToFile);
  try {
    await writeFile(pathToFile, content, encoding);
    return pathToFile;
  } catch (err) {
    throw new Error(`qm-fs-touch - touch(): ${err.message}`);
  }
}

const throwErrorCannotOverWrite = pathToFile => {
  throw new Error(`qm-fs-touch - touch(): Can not touch file (${pathToFile}), because overwrite flag is set to false!`);
};

exports.default = touch;