import fs from 'fs';
import util from 'util';
import ifExists from 'qm-fs-ifexists';

const writeFile = util.promisify(fs.writeFile); //TODOC: node 8 only

async function touch(pathToFile, content, options = {}) {
  const { //TODOC:  options
    encoding = 'utf8',
    overwrite = false,
  } = options;
  const pathIfExists = await ifExists(pathToFile, {asBoolean: true});
  overwrite === false && pathIfExists && throwErrorCannotOverWrite(pathToFile);
  try {
    await writeFile(pathToFile, content, encoding);
    return pathToFile;
  } catch (err) {
    throw new Error(`qm-fs-touch - touch(): ${err.message}`);
  }
}

const throwErrorCannotOverWrite = (pathToFile) => {
  throw new Error(`qm-fs-touch - touch(): Can not touch file (${pathToFile}), because overwrite flag is set to false!`);
};

export default touch;